# Create Journal entries

> Source: https://truto.one/docs/api-reference/unified-accounting-api/journalentries/create/

`POST /unified/accounting/journal_entries`

Resource: **JournalEntries** · API: **Unified Accounting API**

## Supported integrations

ERPNext, QuickBooks, Xero

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.

## Request body

- **`company`** _(string)_
  The company the journal entry belongs to
- **`memo`** _(string)_
  The private note of the journal entry
- **`is_multi_currency`** _(boolean)_
  Whether this journal entry involves multiple currencies.
- **`is_opening_balance`** _(boolean)_
  Whether this journal entry is an opening balance entry.
- **`lines`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier for line item
  - **`name`** _(string)_
    The name of the line item
  - **`description`** _(string)_
    The description of the line item
  - **`item`** _(string)_
    The ID of the item
  - **`account`** _(string)_
    The ID of the account
  - **`quantity`** _(number)_
    The quantity of the line item
  - **`unit_price`** _(number)_
    The unit price of the line item
  - **`tax_rate`** _(string)_
    The ID of the tax rate
  - **`total_line_amount`** _(number)_
    The total line amount of the line item.
  - **`type`** _(string)_
    The type of the line item
  - **`tracking_categories`** _(array<object>)_
    Tracking categories of the line item
    - **`id`** _(string)_
      The ID of the tracking category
    - **`name`** _(string)_
      The name of the tracking category
    - **`option`** _(string)_
      The option of the tracking category
  - **`currency`** _(string)_
    The currency of the line item
  - **`exchange_rate`** _(number)_
    The exchange rate of the currency for the line item
  - **`related_entity_type`** _(string)_
    The type of business entity this journal line relates to
  - **`related_entity_name`** _(string)_
    The name or ID of the entity in the accounting system
  - **`account_id`** _(string)_
    The unique identifier for the account.
  - **`account_code`** _(string, required)_
    The code for the account.
- **`posting`** _(string)_
  For Quickbooks. The type of the posting in journal.
  Allowed: `Credit`, `Debit`
- **`narration`** _(string)_
  The narration for the journal entry
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The unique identifier for journal entries
- **`payments`** _(array<object>)_
  The payments of the journal entry
  - **`id`** _(string)_
    The unique identifier for payment
  - **`payment_for`** _(string)_
    What entity was the payment for. Can be invoice or bill.
    Allowed: `invoice`, `bill`
  - **`contact`** _(object)_
    The contact of the payment
    - **`id`** _(string)_
      The ID of the contact
    - **`type`** _(string)_
      The type of the contact. Can be customer or vendor.
      Allowed: `customer`, `vendor`
- **`memo`** _(string)_
  The private note of the journal entry
- **`type`** _(string)_
  The type of the journal entry
  Allowed: `ACCOUNTS_RECEIVABLE`, `ACCOUNTS_PAYABLE`, `GENERAL`, `STATISTICAL`
- **`currency`** _(string)_
  The currency of the journal entry
- **`exchange_rate`** _(number)_
  The exchange rate of the journal entry
- **`company`** _(string)_
  The company the journal entry belongs to
- **`lines`** _(array<object>)_
  - **`id`** _(string)_
    The unique identifier for line item
  - **`name`** _(string)_
    The name of the line item
  - **`description`** _(string)_
    The description of the line item
  - **`item`** _(string)_
    The ID of the item
  - **`account`** _(string)_
    The ID of the account
  - **`quantity`** _(number)_
    The quantity of the line item
  - **`unit_price`** _(number)_
    The unit price of the line item
  - **`tax_rate`** _(string)_
    The ID of the tax rate
  - **`total_line_amount`** _(number)_
    The total line amount of the line item.
  - **`type`** _(string)_
    The type of the line item
  - **`tracking_categories`** _(array<object>)_
    Tracking categories of the line item
    - **`id`** _(string)_
      The ID of the tracking category
    - **`name`** _(string)_
      The name of the tracking category
    - **`option`** _(string)_
      The option of the tracking category
  - **`currency`** _(string)_
    The currency of the line item
  - **`exchange_rate`** _(number)_
    The exchange rate of the currency for the line item
- **`created_at`** _(string)_
  This represents the date when the journal entry was created
- **`updated_at`** _(string)_
  This represents the date when the journal entry was updated
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/accounting/journal_entries?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "company": "your_company",
  "memo": "your_memo",
  "is_multi_currency": true,
  "is_opening_balance": true,
  "lines": [],
  "posting": "Credit",
  "narration": "your_narration",
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "company": "your_company",
  "memo": "your_memo",
  "is_multi_currency": true,
  "is_opening_balance": true,
  "lines": [],
  "posting": "Credit",
  "narration": "your_narration",
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/accounting/journal_entries?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/accounting/journal_entries"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "company": "your_company",
    "memo": "your_memo",
    "is_multi_currency": True,
    "is_opening_balance": True,
    "lines": [],
    "posting": "Credit",
    "narration": "your_narration",
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'accounting',
  'journalentries',
  {
  "company": "your_company",
  "memo": "your_memo",
  "is_multi_currency": true,
  "is_opening_balance": true,
  "lines": [],
  "posting": "Credit",
  "narration": "your_narration",
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "accounting",
        "journalentries",
        {
        "company": "your_company",
        "memo": "your_memo",
        "is_multi_currency": True,
        "is_opening_balance": True,
        "lines": [],
        "posting": "Credit",
        "narration": "your_narration",
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
